﻿using Asp.Versioning;
using BackendTutorial.Events;
using Infrastructure;
using Infrastructure.EventBus;
using Microsoft.AspNetCore.Mvc;

namespace BackendTutorial.Controllers.V1;

[ApiVersion("1.0")]
[Route("tutorial/{version:apiVersion}")]
public class TutorialController(ILogger<TutorialController> logger, IEventBus eventBus) : DefaultControllerBase
{
    [HttpGet("hello")]
    public async Task<MessageData<string>> HelloAsync()
    {
        logger.LogInformation("hello world");
        return await Task.Run(() => Succeed<string>("hello world"));
    }

    [HttpPost("send")]
    public async Task<MessageData<string>> SendAsync(string message)
    {
        eventBus.Publish(new HelloWorldEvent(message));
        await Task.CompletedTask;
        return Succeed<string>("sent message");
    }
}